package idea.jartool;

import com.intellij.ide.util.TreeClassChooserDialog;
import com.intellij.openapi.application.ApplicationManager;
import com.intellij.openapi.fileChooser.FileChooserDescriptor;
import com.intellij.openapi.fileChooser.FileChooserDialog;
import com.intellij.openapi.fileChooser.FileChooserFactory;
import com.intellij.openapi.module.ModuleManager;
import com.intellij.openapi.project.Project;
import com.intellij.openapi.roots.ModuleRootManager;
import com.intellij.openapi.roots.OrderRootType;
import com.intellij.openapi.vfs.VirtualFile;
import com.intellij.psi.PsiClass;
import com.intellij.psi.PsiMethod;
import com.intellij.psi.search.GlobalSearchScope;
import idea.tableutils.*;

import javax.swing.*;
import javax.swing.event.TableModelListener;
import javax.swing.event.TableModelEvent;
import javax.swing.border.Border;
import javax.swing.border.EtchedBorder;
import javax.swing.table.TableColumn;
import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.util.Collections;
import java.util.Hashtable;
import java.util.Vector;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */

public class ClassSelectionPanel extends JPanel implements ActionListener, KeyListener
{
    Project project;
    JarProject jarProject;

    ManifestTableModel manifestTableModel;
    SingleColumnTableModel fileTableModel;
    SelectionTableModel classTableModel;
    LibraryTableModel libraryTableModel;
    SingleColumnTableModel sourceTableModel;
    DirSelectionTableModel directoryTableModel;

    JSplitPane classTableSplitPanel = new JSplitPane();
    JPanel libraryPanel = new JPanel();
    JScrollPane manifestScroll = new JScrollPane();
    JScrollPane libraryScroll = new JScrollPane();
    JScrollPane sourceScroll = new JScrollPane();
    JScrollPane fileScroll = new JScrollPane();
    JScrollPane classScroll = new JScrollPane();
    JTable manifestTable = new JTable();
    JTable libraryTable = new JTable();
    JTable sourceTable = new JTable();
    JTable fileTable = new JTable();
    JTable classTable = new JTable();
    GridBagLayout gridBagLayout3 = new GridBagLayout();
    JTable directoryTable = new JTable();
    JScrollPane directoryScroll = new JScrollPane();
    JPopupMenu popupJar = new JPopupMenu();
    JMenuItem selectJarsMenu = new JMenuItem();
    JMenuItem removeJarsMenu = new JMenuItem();

    JPopupMenu popupSource = new JPopupMenu();
    JMenuItem selectSourceMenu = new JMenuItem();
    JMenuItem removeSourceMenu = new JMenuItem();

    JButton moveUpButton = new JButton();
    JButton moveDownButton = new JButton();

    JTabbedPane tabbedPane = new JTabbedPane();
    JPopupMenu popupFiles = new JPopupMenu();
    JMenuItem selectFilesMenu = new JMenuItem();
    JMenuItem removeFilesMenu = new JMenuItem();
    JPanel propertiesPanel = new JPanel();
    JTextField nameText = new JTextField();
    JLabel nameLbl = new JLabel();
    GridBagLayout gridBagLayout2 = new GridBagLayout();
    JCheckBox buildSourceCheck = new JCheckBox();
    JCheckBox singleSourceCheck = new JCheckBox();
    JCheckBox buildProjectCheck = new JCheckBox();
    JLabel archiveDirLabel = new JLabel();
    JTextField archiveDirText = new JTextField();
    JButton archiveDirButton = new JButton();
    Border border1;
    JLabel mainClassLbl = new JLabel();
    JTextField mainClassText = new JTextField();
    JTextField versionText = new JTextField();
    JButton mainClasssButton = new JButton();
    JLabel signedPathLabel = new JLabel();
    JTextField signedPathText = new JTextField();

    JLabel sourceNameLabel = new JLabel();
    JTextField sourceNameText = new JTextField();

    JLabel sourceDirLabel = new JLabel();
    JTextField sourceDirText = new JTextField();
    JButton sourceDirButton = new JButton();

    JPopupMenu popupSelectDir = new JPopupMenu();
    JMenuItem selectAllDir = new JMenuItem();
    JMenuItem deSelectAllDir = new JMenuItem();

    JPopupMenu popupSelectClass = new JPopupMenu();
    JMenuItem selectAllClass = new JMenuItem();
    JMenuItem deSelectAllClass = new JMenuItem();
    JCheckBox includeAllprojResCheck = new JCheckBox();

    public ClassSelectionPanel()
    {
        try
        {
            jbInit();
            setupGUI();
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
        }
    }

    void jbInit() throws Exception
    {
        border1 = new EtchedBorder(EtchedBorder.RAISED, Color.white, new Color(148, 145, 140));
        this.setLayout(new GridBagLayout());
        fileScroll.setMaximumSize(new Dimension(100, 100));
        fileScroll.setMinimumSize(new Dimension(100, 100));
        fileScroll.setPreferredSize(new Dimension(100, 100));
        libraryScroll.setMaximumSize(new Dimension(100, 100));
        libraryScroll.setMinimumSize(new Dimension(100, 100));
        libraryScroll.setPreferredSize(new Dimension(100, 100));
        classScroll.setMaximumSize(new Dimension(100, 100));
        classScroll.setMinimumSize(new Dimension(100, 100));
        classScroll.setPreferredSize(new Dimension(100, 100));
        directoryScroll.setPreferredSize(new Dimension(100, 100));
        directoryScroll.setMinimumSize(new Dimension(100, 100));
        directoryScroll.setMaximumSize(new Dimension(100, 100));
        manifestScroll.setPreferredSize(new Dimension(100, 100));
        manifestScroll.setMinimumSize(new Dimension(100, 100));
        manifestScroll.setMaximumSize(new Dimension(100, 100));
        selectJarsMenu.setText("Add Jars");
        selectJarsMenu.addActionListener(this);
        removeJarsMenu.setText("Remove Jars");
        removeJarsMenu.addActionListener(this);

        selectSourceMenu.setText("Add Sources");
        selectSourceMenu.addActionListener(this);
        removeSourceMenu.setText("Remove Sources");
        removeSourceMenu.addActionListener(this);
        includeAllprojResCheck.setHorizontalTextPosition(SwingConstants.LEFT);
        includeAllprojResCheck.setText("Include All Project Resources");
        popupSource.add(selectSourceMenu);
        popupSource.add(removeSourceMenu);

        selectFilesMenu.setText("Add Files");
        selectFilesMenu.addActionListener(this);
        removeFilesMenu.setText("Remove Files");
        removeFilesMenu.addActionListener(this);

        selectAllDir.setText("Select All");
        selectAllDir.addActionListener(this);
        deSelectAllDir.setText("De-Select All");
        deSelectAllDir.addActionListener(this);
        popupSelectDir.add(selectAllDir);
        popupSelectDir.add(deSelectAllDir);

        selectAllClass.setText("Select All");
        selectAllClass.addActionListener(this);
        deSelectAllClass.setText("De-Select All");
        deSelectAllClass.addActionListener(this);
        popupSelectClass.add(selectAllClass);
        popupSelectClass.add(deSelectAllClass);

        nameLbl.setText("Archive Name");
        propertiesPanel.setLayout(gridBagLayout2);
        buildSourceCheck.setText("Build Source Archive");
        buildSourceCheck.setMargin(new Insets(0, 0, 0, 0));
        archiveDirLabel.setText("Archive Target Dir.");
        signedPathLabel.setText("Path to Signed Libraries");
        archiveDirButton.setMaximumSize(new Dimension(21, 21));
        archiveDirButton.setMinimumSize(new Dimension(21, 21));
        archiveDirButton.setPreferredSize(new Dimension(21, 21));
        archiveDirButton.setMargin(new Insets(0, 0, 0, 0));
        archiveDirButton.setText("...");
        propertiesPanel.setBorder(border1);
        archiveDirText.setText("");
        mainClassLbl.setText("Main Class");
        mainClasssButton.setMaximumSize(new Dimension(21, 21));
        mainClasssButton.setMinimumSize(new Dimension(21, 21));
        mainClasssButton.setPreferredSize(new Dimension(21, 21));
        mainClasssButton.setMargin(new Insets(0, 0, 0, 0));
        mainClasssButton.setText("...");

        sourceDirButton.setMaximumSize(new Dimension(21, 21));
        sourceDirButton.setMinimumSize(new Dimension(21, 21));
        sourceDirButton.setPreferredSize(new Dimension(21, 21));
        sourceDirButton.setMargin(new Insets(0, 0, 0, 0));
        sourceDirButton.setText("...");

        singleSourceCheck.setText("Extract and add library sources");
        singleSourceCheck.setMargin(new Insets(0, 0, 0, 0));

        buildProjectCheck.setText("Build project before archiving");
        buildProjectCheck.setMargin(new Insets(0, 0, 0, 0));

        classTableSplitPanel.setOrientation(JSplitPane.VERTICAL_SPLIT);

        tabbedPane.add("Archive", propertiesPanel);
        tabbedPane.add("Project Resources", classTableSplitPanel);
        tabbedPane.add("Libraries", libraryPanel);
        tabbedPane.add("Other Files", fileScroll);
        tabbedPane.add("Manifest", manifestScroll);
        tabbedPane.add("Library Sources", sourceScroll);

        classTableSplitPanel.setTopComponent(directoryScroll);
        classTableSplitPanel.setBottomComponent(classScroll);
        classTableSplitPanel.setDividerLocation(200);

        sourceDirLabel.setText("Source Target Dir.");
        sourceNameLabel.setText("Source Archive Name");

        libraryPanel.setLayout(new GridBagLayout());
        libraryPanel.add(libraryScroll, new GridBagConstraints(0, 0, 1, 2, 1.0, 1.0
            , GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));

        moveUpButton.setPreferredSize(new Dimension(30, 30));
        moveDownButton.setPreferredSize(new Dimension(30, 30));
        moveUpButton.setIcon(new ImageIcon(ClassSelectionPanel.class.getResource("images/move_up.gif")));
        moveDownButton.setIcon(new ImageIcon(ClassSelectionPanel.class.getResource("images/move_down.gif")));
        libraryPanel.add(moveUpButton, new GridBagConstraints(1, 0, 1, 1, 0.0, 1.0
            , GridBagConstraints.SOUTH, GridBagConstraints.NONE, new Insets(6, 6, 6, 6), 0, 0));
        libraryPanel.add(moveDownButton, new GridBagConstraints(1, 1, 1, 1, 0.0, 1.0
            , GridBagConstraints.NORTH, GridBagConstraints.NONE, new Insets(6, 6, 6, 6), 0, 0));


        buildSourceCheck.setHorizontalTextPosition(SwingConstants.LEFT);
        singleSourceCheck.setHorizontalTextPosition(SwingConstants.LEFT);
        buildProjectCheck.setHorizontalTextPosition(SwingConstants.LEFT);
        this.add(tabbedPane, new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0
            , GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
        classScroll.getViewport().add(classTable, null);
        directoryScroll.getViewport().add(directoryTable, null);
        fileScroll.getViewport().add(fileTable, null);
        libraryScroll.getViewport().add(libraryTable, null);
        manifestScroll.getViewport().add(manifestTable, null);
        sourceScroll.getViewport().add(sourceTable, null);

        popupJar.add(selectJarsMenu);
        popupJar.add(removeJarsMenu);
        popupFiles.add(selectFilesMenu);
        popupFiles.add(removeFilesMenu);

        propertiesPanel.add(new JLabel("Version"), new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(6, 6, 6, 6), 0, 0));
        propertiesPanel.add(versionText, new GridBagConstraints(1, 0, 2, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(6, 6, 6, 0), 0, 0));

        propertiesPanel.add(nameLbl, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(6, 6, 6, 6), 0, 0));
        propertiesPanel.add(nameText, new GridBagConstraints(1, 1, 2, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(6, 6, 6, 0), 0, 0));
        propertiesPanel.add(includeAllprojResCheck, new GridBagConstraints(3, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(6, 6, 6, 6), 0, 0));

        propertiesPanel.add(archiveDirLabel, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(6, 6, 6, 6), 0, 0));
        propertiesPanel.add(archiveDirText, new GridBagConstraints(1, 2, 3, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(6, 6, 6, 6), 0, 0));
        propertiesPanel.add(archiveDirButton, new GridBagConstraints(4, 2, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(6, 0, 6, 6), 0, 0));

        propertiesPanel.add(signedPathLabel, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(6, 6, 6, 6), 0, 0));
        propertiesPanel.add(signedPathText, new GridBagConstraints(1, 3, 3, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(6, 6, 6, 6), 0, 0));

        propertiesPanel.add(mainClassLbl, new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(6, 6, 6, 6), 0, 0));
        propertiesPanel.add(mainClassText, new GridBagConstraints(1, 4, 3, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(6, 6, 6, 6), 0, 0));
        propertiesPanel.add(mainClasssButton, new GridBagConstraints(4, 4, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(6, 0, 6, 6), 0, 0));

        propertiesPanel.add(buildSourceCheck, new GridBagConstraints(0, 5, 2, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(6, 5, 6, 6), 0, 0));
        propertiesPanel.add(singleSourceCheck, new GridBagConstraints(2, 5, 2, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(6, 18, 6, 6), 0, 0));

        propertiesPanel.add(sourceNameLabel, new GridBagConstraints(0, 6, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(6, 6, 6, 6), 0, 0));
        propertiesPanel.add(sourceNameText, new GridBagConstraints(1, 6, 3, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(6, 6, 6, 6), 0, 0));

        propertiesPanel.add(sourceDirLabel, new GridBagConstraints(0, 7, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(6, 6, 6, 6), 0, 0));
        propertiesPanel.add(sourceDirText, new GridBagConstraints(1, 7, 3, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(6, 6, 6, 6), 0, 0));
        propertiesPanel.add(sourceDirButton, new GridBagConstraints(4, 7, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(6, 0, 6, 6), 0, 0));

        propertiesPanel.add(buildProjectCheck, new GridBagConstraints(0, 8, 2, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(6, 5, 6, 6), 0, 0));

    }

    /**
     *
     */
    void setupGUI()
    {
        TableColumn column;
        JCheckBox editorCheckBox = new JCheckBox();

        SortButtonRenderer sortButtonrenderer = new SortButtonRenderer();

        /**
         * File table to select other resources
         * any file including configurations etc can be selected via this
         */
        //just the display in one column, can be remove from the table if not needed
        fileTableModel = new SingleColumnTableModel("Files");

        fileTable.setAutoCreateColumnsFromModel(false);
        fileTable.setModel(fileTableModel);
        fileTable.getTableHeader().setReorderingAllowed(false);

        fileTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
        fileTable.setAutoResizeMode(JTable.AUTO_RESIZE_LAST_COLUMN);
        fileTable.getTableHeader().addMouseListener(new SortableHeaderListner(fileTable.getTableHeader(), sortButtonrenderer));
        for (int k = 0; k < fileTableModel.getColumnCount(); k++)
        {
            CGCellRenderer textRenderer = new CGCellRenderer();
            textRenderer.setHorizontalAlignment(fileTableModel.getColumn(k).getAlignment());
            column = new TableColumn(k, fileTableModel.getColumn(k).getWidth(), textRenderer, null);
            column.setHeaderRenderer(sortButtonrenderer);
            fileTable.addColumn(column);
        }

        /**
         * Class Table
         *
         * selecting of classes, all the classes wil be listed here they can be selected
         * by the select checkbox on 1st col
         */
        classTableModel = new SelectionTableModel("Resources");

        classTable.setAutoCreateColumnsFromModel(false);
        classTable.setModel(classTableModel);
        classTable.getTableHeader().setReorderingAllowed(false);

        classTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        classTable.setAutoResizeMode(JTable.AUTO_RESIZE_LAST_COLUMN);
        classTable.getTableHeader().addMouseListener(new SortableHeaderListner(classTable.getTableHeader(), sortButtonrenderer));

        for (int k = 0; k < classTableModel.getColumnCount(); k++)
        {
            if (k == 0)
            {
                SelectionCheckCellRenderer chkRenderer = new SelectionCheckCellRenderer();
                chkRenderer.setHorizontalAlignment(classTableModel.getColumn(k).getAlignment());
                editorCheckBox.setHorizontalAlignment(classTableModel.getColumn(k).getAlignment());
                DefaultCellEditor editor = new DefaultCellEditor(editorCheckBox);
                column = new TableColumn(k, classTableModel.getColumn(k).getWidth(), chkRenderer, editor);
            }
            else
            {
                SelectionCellRenderer textRenderer = new SelectionCellRenderer();
                textRenderer.setHorizontalAlignment(classTableModel.getColumn(k).getAlignment());
                column = new TableColumn(k, classTableModel.getColumn(k).getWidth(), textRenderer, null);
            }
            column.setHeaderRenderer(sortButtonrenderer);
            classTable.addColumn(column);
        }

        /**
         * Package Table
         *
         * classes can be selected by directory based, if the directory is being selected its all the classes
         * are automatically selected
         * all the class directories are included here, since the directories are generated based on the
         * package name, this is similar to the package wise selection, hoever if the same package level is in
         * more than one Module and the modules have dependedncies they
         * need to be selected in each module
         */
        directoryTableModel = new DirSelectionTableModel("Directories", classTableModel);

        directoryTable.setAutoCreateColumnsFromModel(false);
        directoryTable.setModel(directoryTableModel);
        directoryTable.getTableHeader().setReorderingAllowed(false);

        directoryTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        directoryTable.setAutoResizeMode(JTable.AUTO_RESIZE_LAST_COLUMN);

        directoryTable.getTableHeader().addMouseListener(new SortableHeaderListner(directoryTable.getTableHeader(), sortButtonrenderer));

        for (int k = 0; k < directoryTableModel.getColumnCount(); k++)
        {
            if (k == 0)
            {
                SelectionCheckCellRenderer chkRenderer = new SelectionCheckCellRenderer();
                chkRenderer.setHorizontalAlignment(directoryTableModel.getColumn(k).getAlignment());
                editorCheckBox.setHorizontalAlignment(directoryTableModel.getColumn(k).getAlignment());
                DefaultCellEditor editor = new DefaultCellEditor(editorCheckBox);
                column = new TableColumn(k, directoryTableModel.getColumn(k).getWidth(), chkRenderer, editor);
            }
            else
            {
                SelectionCellRenderer textRenderer = new SelectionCellRenderer();
                textRenderer.setHorizontalAlignment(directoryTableModel.getColumn(k).getAlignment());
                column = new TableColumn(k, directoryTableModel.getColumn(k).getWidth(), textRenderer, null);
            }
            column.setHeaderRenderer(sortButtonrenderer);
            directoryTable.addColumn(column);
        }

        /**
         * Jar table
         */
        libraryTableModel = new LibraryTableModel();

        libraryTable.setAutoCreateColumnsFromModel(false);
        libraryTable.setModel(libraryTableModel);
        libraryTable.getTableHeader().setReorderingAllowed(false);

        libraryTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
        libraryTable.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);

        for (int k = 0; k < libraryTableModel.getColumnCount(); k++)
        {
            if (k == 1)
            {
                CheckCellRenderer renderer = new CheckCellRenderer();
                renderer.setHorizontalAlignment(libraryTableModel.getColumn(k).getAlignment());
                column = new TableColumn(k, libraryTableModel.getColumn(k).getWidth(), renderer, new DefaultCellEditor(editorCheckBox));
            }
            else
            {
                CGCellRenderer textRenderer = new CGCellRenderer();
                textRenderer.setHorizontalAlignment(libraryTableModel.getColumn(k).getAlignment());
                column = new TableColumn(k, libraryTableModel.getColumn(k).getWidth(), textRenderer, null);
            }
            libraryTable.addColumn(column);
        }

        /**
         * Source
         */
        sourceTableModel = new SingleColumnTableModel("Sources");

        sourceTable.setAutoCreateColumnsFromModel(false);
        sourceTable.setModel(sourceTableModel);
        sourceTable.getTableHeader().setReorderingAllowed(false);

        sourceTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
        sourceTable.setAutoResizeMode(JTable.AUTO_RESIZE_LAST_COLUMN);
        sourceTable.getTableHeader().addMouseListener(new SortableHeaderListner(sourceTable.getTableHeader(), sortButtonrenderer));

        for (int k = 0; k < sourceTableModel.getColumnCount(); k++)
        {
            CGCellRenderer textRenderer = new CGCellRenderer();
            textRenderer.setHorizontalAlignment(sourceTableModel.getColumn(k).getAlignment());
            column = new TableColumn(k, sourceTableModel.getColumn(k).getWidth(), textRenderer, null);
            column.setHeaderRenderer(sortButtonrenderer);
            sourceTable.addColumn(column);
        }

        /**
         * Source
         */
        manifestTableModel = new ManifestTableModel();

        manifestTable.setAutoCreateColumnsFromModel(false);
        manifestTable.setModel(manifestTableModel);
        manifestTable.getTableHeader().setReorderingAllowed(false);

        manifestTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
        manifestTable.setAutoResizeMode(JTable.AUTO_RESIZE_LAST_COLUMN);
        manifestTable.getTableHeader().addMouseListener(new SortableHeaderListner(manifestTable.getTableHeader(), sortButtonrenderer));

        for (int k = 0; k < manifestTableModel.getColumnCount(); k++)
        {
            CGCellRenderer textRenderer = new CGCellRenderer();
            textRenderer.setHorizontalAlignment(manifestTableModel.getColumn(k).getAlignment());
            column = new TableColumn(k, manifestTableModel.getColumn(k).getWidth(), textRenderer, null);
            column.setHeaderRenderer(sortButtonrenderer);
            manifestTable.addColumn(column);
        }

        manifestTableModel.addTableModelListener(new TableModelListener()
        {
            public void tableChanged(TableModelEvent e)
            {
                versionText.setText(jarProject.getVersion());
                mainClassText.setText(jarProject.getMainClass());
            }
        });

        MouseListener mouseListener = new MouseAdapter()
        {
            public void mouseReleased(MouseEvent e)
            {
                if (e.isPopupTrigger())
                {
                    if (e.getSource() == libraryScroll || e.getSource() == libraryTable)
                    {
                        popupJar.show((Component) e.getSource(), e.getX(), e.getY());
                    }
                    else if (e.getSource() == fileScroll || e.getSource() == fileTable)
                    {
                        popupFiles.show((Component) e.getSource(), e.getX(), e.getY());
                    }
                    else if (e.getSource() == directoryScroll || e.getSource() == directoryTable)
                    {
                        popupSelectDir.show((Component) e.getSource(), e.getX(), e.getY());
                    }
                    else if (e.getSource() == classScroll || e.getSource() == classTable)
                    {
                        popupSelectClass.show((Component) e.getSource(), e.getX(), e.getY());
                    }
                    else if (e.getSource() == sourceScroll || e.getSource() == sourceTable)
                    {
                        popupSource.show((Component) e.getSource(), e.getX(), e.getY());
                    }
                }
            }
        };

        libraryScroll.addMouseListener(mouseListener);
        libraryTable.addMouseListener(mouseListener);
        fileScroll.addMouseListener(mouseListener);
        fileTable.addMouseListener(mouseListener);
        directoryScroll.addMouseListener(mouseListener);
        directoryTable.addMouseListener(mouseListener);
        classScroll.addMouseListener(mouseListener);
        classTable.addMouseListener(mouseListener);
        sourceTable.addMouseListener(mouseListener);
        sourceScroll.addMouseListener(mouseListener);

        mainClasssButton.addActionListener(this);
        archiveDirButton.addActionListener(this);
        sourceDirButton.addActionListener(this);
        buildSourceCheck.addActionListener(this);
        includeAllprojResCheck.addActionListener(this);
        moveDownButton.addActionListener(this);
        moveUpButton.addActionListener(this);

        versionText.addKeyListener(this);
        mainClassText.addKeyListener(this);
        libraryTable.addKeyListener(this);
        fileTable.addKeyListener(this);
        sourceTable.addKeyListener(this);
    }

    /**
     * @param project
     * @param jarProject setting data from outside, the filed will be updated based on the
     *                   data sent
     */
    public void setData(Project project, JarProject jarProject)
    {
        this.project = project;
        this.jarProject = jarProject;

        this.nameText.setText(jarProject.getArchiveName());
        this.versionText.setText(jarProject.getVersion());
        this.archiveDirText.setText(jarProject.getArchiveDir());
        this.signedPathText.setText(jarProject.getSignedLibraryPath());
        this.buildSourceCheck.setSelected(jarProject.isBuildSourceArchive());
        this.singleSourceCheck.setSelected(jarProject.isSingleSourceArchive());
        this.mainClassText.setText(jarProject.getMainClass());
        this.sourceDirText.setText(jarProject.getSourceDir());
        this.sourceNameText.setText(jarProject.getSourceName());
        this.includeAllprojResCheck.setSelected(jarProject.isIncludeAllProjectResources());
        this.buildProjectCheck.setSelected(jarProject.isBuildBeforeArchiving());

        this.manifestTableModel.setJarProject(jarProject);
        this.manifestTableModel.setData(jarProject.getManifestEntries());
        loadData();
        resetEnabling();
    }

    /**
     * all the classes will be loaded in the the classs tabele automatically
     * user can select them afterwards, directories will be generated based on the classes
     * directoreis and their sub directories
     * <p/>
     * all the others will be displayed based on the setup. Only the selected libraries,
     */
    public void loadData()
    {
        classTableModel.getData().clear();
        directoryTableModel.getData().clear();

        classTableModel.getData().addAll(ApplicationManager.getApplication().getComponent(JarPlugin.class).loadClasses(project, jarProject));

        Hashtable<String, String> dirHash = new Hashtable<String, String>();

        for (int i = 0; i < classTableModel.getData().size(); i++)
        {
            SelectionItem selectionItem = (SelectionItem) classTableModel.getData().elementAt(i);

            String dir = selectionItem.getValue().substring(0, selectionItem.getValue().lastIndexOf(File.separator));

            if (!dirHash.containsKey(dir))
            {
                dirHash.put(dir, dir);

                SelectionItem dirItem = new SelectionItem(jarProject.getDirectories().contains(dir),
                                                          dir);
                directoryTableModel.getData().addElement(dirItem);
            }
        }

        libraryTableModel.getData().clear();
        for (int i = 0; i < jarProject.getLibraries().size(); i++)
        {
            libraryTableModel.getData().addElement(jarProject.getLibraries().elementAt(i));
        }

        sourceTableModel.getData().clear();
        for (int i = 0; i < jarProject.getSources().size(); i++)
        {
            sourceTableModel.getData().addElement(jarProject.getSources().elementAt(i).toString());
        }

        fileTableModel.getData().clear();
        for (int i = 0; i < jarProject.getResources().size(); i++)
        {
            fileTableModel.getData().addElement(jarProject.getResources().elementAt(i).toString());
        }

        //all are needed to be selected 
        if (jarProject.isIncludeAllProjectResources())
        {
            setClassSelectionStatus(true);
        }

        Collections.sort(classTableModel.getData());
        Collections.sort(directoryTableModel.getData());

        classTableModel.fireTableDataChanged();
        libraryTableModel.fireTableDataChanged();
        directoryTableModel.fireTableDataChanged();
        fileTableModel.fireTableDataChanged();
        sourceTableModel.fireTableDataChanged();
    }


    /**
     * load all the jars from the clasas path, then the user can select the libraries he wants
     * all the libraries from the modules will be loaded by this
     */
    Vector<SelectionItem> loadJars()
    {
        Vector<SelectionItem> jars = new Vector<SelectionItem>();

        ModuleManager moduleManager = ModuleManager.getInstance(project);

        ModuleRootManager mrm = ModuleRootManager.getInstance(moduleManager.findModuleByName(project.getName()));
        VirtualFile files[] = mrm.getFiles(OrderRootType.CLASSES_AND_OUTPUT);

        for (VirtualFile file : files)
        {
            if (file.getPresentableUrl().trim().endsWith(".jar"))
            {
                SelectionItem item = new SelectionItem(isJarAlreadySelected(file.getPresentableUrl().trim()),
                                                       file.getPresentableUrl().trim());
                jars.addElement(item);
            }
        }

        return jars;
    }

    //check the library is already selected in to the build archive
    boolean isJarAlreadySelected(String name)
    {
        for (int i = 0; i < libraryTableModel.getData().size(); i++)
        {
            if ( ( ( Library ) libraryTableModel.getData().elementAt(i) ).getPath().equals(name))
            {
                return true;
            }
        }
        return false;
    }

    /**
     * selecting the jarfiles, this will avoid the selection of libraries
     * by selecting twice
     */
    void selectJars()
    {
        try
        {
            SelectionDialog dialog = new SelectionDialog(true);
            dialog.setTitle("Available Jars");
            dialog.setSize(600, 400);
            dialog.setData(loadJars());
            dialog.show();

            if (!dialog.isCancelled())
            {
                Vector data = dialog.getData();

                /**
                 * when adding the libraries the order which the current libs are set
                 * shold be kept unchanged, hence the selected items are added to the list in the
                 * same order as currnet, any new one will be added to the end of the lib list
                 */
                Vector currentData = (Vector) libraryTableModel.getData().clone();

                libraryTableModel.getData().clear();

                for (int i = 0; i < currentData.size(); i++)
                {
                    String existingLibName = ((Library) currentData.elementAt(i)).getPath();

                    for (int j = 0; j < data.size(); j++)
                    {
                        SelectionItem item = (SelectionItem) data.elementAt(j);

                        if (item.isSelected() && item.getValue().equals(existingLibName))
                        {
                            libraryTableModel.getData().addElement( currentData.elementAt(i) );
                            //remove the added element from the list
                            data.removeElementAt(j);
                            j--;
                        }
                    }
                }

                /**
                 * if there are more in the dat they are newly selected items, add them to the bottom
                 * of the list
                 */
                for (int i = 0; i < data.size(); i++)
                {
                    SelectionItem item = (SelectionItem) data.elementAt(i);

                    if (item.isSelected())
                    {
                        libraryTableModel.getData().addElement(new Library( item.getValue(),false) );
                    }
                }

                libraryTableModel.fireTableDataChanged();
            }
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
        }
    }

    /**
     * remove selected libraries from the project
     * multiple removal is allowed
     */
    void removeJars()
    {
        int[] rows = libraryTable.getSelectedRows();

        Vector rowData = new Vector();
        for (int row : rows)
        {
            rowData.addElement(libraryTableModel.getData().elementAt(row));
        }

        libraryTableModel.getData().removeAll(rowData);
        libraryTableModel.fireTableDataChanged();

        if (!libraryTableModel.getData().isEmpty())
        {
            libraryTable.setRowSelectionInterval(rows[rows.length - 1] - rowData.size(), rows[rows.length - 1] - rowData.size());
        }

    }

    /**
     * load all the sources libraries and source paths
     */
    Vector<SelectionItem> loadSrcs()
    {
        Vector<SelectionItem> srcs = new Vector<SelectionItem>();

        ModuleManager moduleManager = ModuleManager.getInstance(project);

        ModuleRootManager mrm = ModuleRootManager.getInstance(moduleManager.findModuleByName(project.getName()));
        VirtualFile files[] = mrm.getFiles(OrderRootType.SOURCES);

        for (VirtualFile file : files)
        {
            if (file.getPresentableUrl().trim().endsWith(".jar") ||
                file.getPresentableUrl().trim().endsWith(".zip"))
            {
                SelectionItem item = new SelectionItem(isSourceAlreadySelected(file.getPresentableUrl().trim()),
                                                       file.getPresentableUrl().trim());
                srcs.addElement(item);
            }
        }

        return srcs;
    }


    //check the Source library is already selected in to the build archive
    boolean isSourceAlreadySelected(String name)
    {
        for (int i = 0; i < sourceTableModel.getData().size(); i++)
        {
            if (sourceTableModel.getData().elementAt(i).toString().equals(name))
            {
                return true;
            }
        }
        return false;
    }

    /**
     * select source libraries or paths with no duplicates
     */
    void selectSrcs()
    {
        try
        {
            SelectionDialog dialog = new SelectionDialog(true);
            dialog.setTitle("Available Sources");
            dialog.setSize(300, 400);
            dialog.setData(loadSrcs());
            dialog.show();

            if (!dialog.isCancelled())
            {
                Vector data = dialog.getData();

                sourceTableModel.getData().clear();

                for (int i = 0; i < data.size(); i++)
                {
                    SelectionItem item = (SelectionItem) data.elementAt(i);

                    if (item.isSelected())
                    {
                        sourceTableModel.getData().addElement(item.getValue());
                    }
                }

                sourceTableModel.fireTableDataChanged();
            }
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
        }
    }

    /**
     * removal of source archive, multiple removal at once is allowed
     */
    void removeSrcs()
    {
        int[] rows = sourceTable.getSelectedRows();

        Vector rowData = new Vector();
        for (int row : rows)
        {
            rowData.addElement(sourceTableModel.getData().elementAt(row));
        }

        sourceTableModel.getData().removeAll(rowData);
        sourceTableModel.fireTableDataChanged();

        if (!sourceTableModel.getData().isEmpty())
        {
            sourceTable.setRowSelectionInterval(rows[rows.length - 1] - rowData.size(), rows[rows.length - 1] - rowData.size());
        }

    }

    /**
     * selecting files to the build. configurations or any other file can be atthed.
     */
    void selectFiles()
    {
        FileChooserDialog dlg = FileChooserFactory.getInstance().createFileChooser(new FileChooserDescriptor(true, false, false, false, false, true), project);
        VirtualFile[] vFiles = dlg.choose(null, project);

        for (VirtualFile vFile : vFiles)
        {
            if (!fileTableModel.getData().contains(vFile.getPath()))
            {
                fileTableModel.getData().addElement(vFile.getPresentableUrl());
            }
        }
        fileTableModel.fireTableDataChanged();
    }

    void removeFiles()
    {
        int[] rows = fileTable.getSelectedRows();

        Vector rowData = new Vector();
        for (int row : rows)
        {
            rowData.addElement(fileTableModel.getData().elementAt(row));
        }

        fileTableModel.getData().removeAll(rowData);
        fileTableModel.fireTableDataChanged();

        if (!fileTableModel.getData().isEmpty())
        {
            fileTable.setRowSelectionInterval(rows[rows.length - 1] - rowData.size(), rows[rows.length - 1] - rowData.size());
        }
    }

    /**
     * save the ui data in to the class, inorder to save in to the file
     */
    public void save()
    {
        jarProject.setArchiveName(this.nameText.getText().trim());
        jarProject.setVersion(this.versionText.getText().trim());
        jarProject.setMainClass(this.mainClassText.getText().trim());
        jarProject.setArchiveDir(this.archiveDirText.getText().trim());
        jarProject.setSignedLibraryPath(this.signedPathText.getText().trim());
        jarProject.setBuildSourceArchive(this.buildSourceCheck.isSelected());
        jarProject.setSingleSourceArchive(this.singleSourceCheck.isSelected());
        jarProject.setSourceDir(this.sourceDirText.getText().trim());
        jarProject.setSourceName(this.sourceNameText.getText().trim());
        jarProject.setIncludeAllProjectResources(this.includeAllprojResCheck.isSelected());
        jarProject.setBuildBeforeArchiving(this.buildProjectCheck.isSelected());

        //libraries and selected jars
        jarProject.getLibraries().clear();
        jarProject.getLibraries().addAll(libraryTableModel.getData());

        //sources
        jarProject.getSources().clear();
        jarProject.getSources().addAll(sourceTableModel.getData());

        //resources
        jarProject.getResources().clear();
        jarProject.getResources().addAll(fileTableModel.getData());

        //classes
        jarProject.getClasses().clear();

        SelectionItem item;
        for (int i = 0; i < classTableModel.getData().size(); i++)
        {
            item = (SelectionItem) classTableModel.getData().elementAt(i);
            if (item.isSelected())
            {
                jarProject.getClasses().addElement(item.getValue());
            }
        }

        //directories
        jarProject.getDirectories().clear();
        for (int i = 0; i < directoryTableModel.getData().size(); i++)
        {
            item = (SelectionItem) directoryTableModel.getData().elementAt(i);
            if (item.isSelected())
            {
                jarProject.getDirectories().addElement(item.getValue());
            }
        }
    }

    public Project getProject()
    {
        return project;
    }

    public JarProject getJarProject()
    {
        return jarProject;
    }

    public void actionPerformed(ActionEvent e)
    {
        if (e.getSource() == selectJarsMenu)
        {
            selectJars();
        }
        else if (e.getSource() == removeJarsMenu)
        {
            removeJars();
        }
        else if (e.getSource() == selectSourceMenu)
        {
            selectSrcs();
        }
        else if (e.getSource() == removeSourceMenu)
        {
            removeSrcs();
        }
        else if (e.getSource() == selectFilesMenu)
        {
            selectFiles();
        }
        else if (e.getSource() == removeFilesMenu)
        {
            removeFiles();
        }
        else if (e.getSource() == mainClasssButton)
        {
            selectMainClass();
        }
        else if (e.getSource() == includeAllprojResCheck)
        {
            resetEnabling();
            setDirectorySelectionStatus(includeAllprojResCheck.isSelected());
        }
        else if (e.getSource() == buildSourceCheck)
        {
            resetEnabling();
        }
        else if (e.getSource() == moveDownButton)
        {
            shift(1);
        }
        else if (e.getSource() == moveUpButton)
        {
            shift(-1);
        }
        else if (e.getSource() == archiveDirButton)
        {
            archiveDirText.setText(selectDir());
        }
        else if (e.getSource() == sourceDirButton)
        {
            sourceDirText.setText(selectDir());
        }
        else if (e.getSource() == selectAllClass)
        {
            setClassSelectionStatus(true);
        }
        else if (e.getSource() == deSelectAllClass)
        {
            setClassSelectionStatus(false);
        }
        else if (e.getSource() == selectAllDir)
        {
            setDirectorySelectionStatus(true);
        }
        else if (e.getSource() == deSelectAllDir)
        {
            setDirectorySelectionStatus(false);
        }
    }

    /**
     * selecting or deseleccting all the classes on that project , (including all the modules)
     *
     * @param selected
     */
    private void setClassSelectionStatus(boolean selected)
    {
        for (int i = 0; i < classTableModel.getData().size(); i++)
        {
            ((SelectionItem) classTableModel.getData().elementAt(i)).setSelected(selected);
        }
        classTableModel.fireTableDataChanged();
    }

    /**
     * selecting or deselecting all the directories of the project in to the build
     * this will again select or deselect classes
     *
     * @param selected
     */
    private void setDirectorySelectionStatus(boolean selected)
    {
        for (int i = 0; i < directoryTableModel.getData().size(); i++)
        {
            ((SelectionItem) directoryTableModel.getData().elementAt(i)).setSelected(selected);
        }
        directoryTableModel.fireTableDataChanged();

        setClassSelectionStatus(selected);
    }


    /**
     * moving the libraries by sets up and down inorder to set the order of the insersion of libraries
     */
    private void shift(int move)
    {
        int[] selRows = libraryTable.getSelectedRows();

        if (selRows != null &&
            selRows.length > 0 &&
            libraryTableModel.getData().size() > 1)
        {
            Vector tempVec = new Vector();
            tempVec.addAll(libraryTableModel.getData());

            Vector tempMoving = new Vector();

            for (int selRow : selRows)
            {
                tempMoving.addElement(tempVec.elementAt(selRow));
            }

            tempVec.removeAll(tempMoving);

            if (selRows[0] + move <= tempVec.size() &&
                selRows[0] + move >= 0)
            {
                tempVec.addAll(selRows[0] + move, tempMoving);

                libraryTableModel.getData().clear();
                libraryTableModel.getData().addAll(tempVec);
                libraryTableModel.fireTableDataChanged();

                libraryTable.setRowSelectionInterval(selRows[0] + move, selRows[selRows.length - 1] + move);
            }
        }
    }

    /**
     * resetting the UI based on the selection of include all classes and
     * build source check boxes
     */
    private void resetEnabling()
    {
        singleSourceCheck.setEnabled(buildSourceCheck.isSelected());
        sourceDirText.setEnabled(buildSourceCheck.isSelected());
        sourceNameText.setEnabled(buildSourceCheck.isSelected());
        sourceDirButton.setEnabled(buildSourceCheck.isSelected());

        /**
         * if all the classes are selcted then no need enabling the class selection
         * and the menus to select all deselect all, the tables are kept in there just to display all
         * the available classes in case the user can see them
         */
        classTableModel.setEditable(!includeAllprojResCheck.isSelected());
        directoryTableModel.setEditable(!includeAllprojResCheck.isSelected());

        selectAllClass.setEnabled(!includeAllprojResCheck.isSelected());
        selectAllDir.setEnabled(!includeAllprojResCheck.isSelected());
        deSelectAllClass.setEnabled(!includeAllprojResCheck.isSelected());
        deSelectAllDir.setEnabled(!includeAllprojResCheck.isSelected());

        if (includeAllprojResCheck.isSelected())
        {
            directoryScroll.setVisible(false);
        }
        else
        {
            directoryScroll.setVisible(true);
            classTableSplitPanel.setDividerLocation(200);
        }
    }

    /**
     * select an direcotry from using the filchooser dialog of idea, and retuns the
     * path as a string. this is used to select the directory to create the source and build
     * archives, source and build can be directed to 2 differnt direcotories
     */
    private String selectDir()
    {
        FileChooserDialog dlg = FileChooserFactory.getInstance().createFileChooser(new FileChooserDescriptor(false, true, false, false, false, false), project);
        VirtualFile[] vFiles = dlg.choose(null, project);

        if (vFiles != null && vFiles.length > 0)
        {
            return vFiles[0].getPresentableUrl();
        }

        return "";
    }

    /**
     * selecting the main class using the class browser to create an executable archive
     * idea tree class chooser with filters is used
     */
    private void selectMainClass()
    {
        //filter to list the classes with main method
        TreeClassChooserDialog.ClassFilter classFilter = new TreeClassChooserDialog.ClassFilter()
        {
            public boolean isAccepted(PsiClass psiClass)
            {
                PsiMethod[] psiMethods = psiClass.getMethods();

                for (PsiMethod psiMethod : psiMethods)
                {
                    if (psiMethod.getName().equals("main") &&
                        psiMethod.getReturnType().getPresentableText().equals("void") &&
                        psiMethod.getModifierList().hasModifierProperty("static") &&
                        psiMethod.getModifierList().hasModifierProperty("public"))
                    {
                        return true;
                    }
                }

                return false;
            }
        };

        //classes from any module
        GlobalSearchScope gss = GlobalSearchScope.moduleWithDependenciesScope(ModuleManager.getInstance(project).findModuleByName(project.getName()));

        TreeClassChooserDialog d = new TreeClassChooserDialog("Select Main Class", project, gss, classFilter, null);
        d.show();

        if (d.isOK())
        {
            mainClassText.setText(d.getSelectedClass().getQualifiedName());
            jarProject.setMainClass(d.getSelectedClass().getQualifiedName());
        }
    }

    public void keyTyped(KeyEvent e)
    {

    }

    public void keyPressed(KeyEvent e)
    {

    }

    public void keyReleased(KeyEvent e)
    {
        if (e.getKeyCode() == KeyEvent.VK_DELETE)
        {
            if (e.getSource() == libraryTable)
            {
                removeJars();
            }
            else if (e.getSource() == sourceTable)
            {
                removeSrcs();
            }
            else if (e.getSource() == fileTable)
            {
                removeFiles();
            }
        }

        if (e.getSource() == versionText)
        {
            jarProject.setVersion(versionText.getText());
        }
        else if (e.getSource() == mainClassText)
        {
            jarProject.setMainClass(mainClassText.getText());
        }

    }
}
