package idea.jartool;

import idea.tableutils.ColumnData;

import javax.swing.*;
import javax.swing.event.TableModelEvent;

import org.apache.tools.ant.taskdefs.Manifest;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */

public class ManifestTableModel extends idea.tableutils.AbstractTableModelImpl
{
    public ColumnData columns[];
    private JarProject jarProject;

    public ManifestTableModel()
    {
        super();
        columns = new ColumnData[ 2 ];
        columns[0] = new ColumnData("Name", 200, JLabel.LEFT);
        columns[1] = new ColumnData("Value", 400, JLabel.LEFT);
    }


    public void setJarProject(JarProject jarProject)
    {
        this.jarProject = jarProject;
    }

    public int getRowCount()
    {
        return data == null ? 0 : data.size();
    }

    public int getColumnCount()
    {
        return columns.length;
    }

    public String getColumnName(int column)
    {
        return columns[column].getTitle();
    }

    public ColumnData getColumn(int row)
    {
        return columns[row];
    }

    // not needed
    public boolean isCellEditable(int nRow, int nCol)
    {
        return true;
    }

    public Object getValueAtRow(Object rowObj, int nCol)
    {
        if (nCol == 0)
        {
            return ((Manifest.Attribute) rowObj ).getName();
        }
        else if( nCol == 1)
        {
            Manifest.Attribute attr = ((Manifest.Attribute) rowObj );

            if ( attr.getName().equals("Main-Class"))
            {
                return jarProject.getMainClass();
            }
            else if ( attr.getName().equals( Manifest.ATTRIBUTE_MANIFEST_VERSION ))
            {
                return jarProject.getVersion();
            }
            else
            {
                return attr.getValue();
            }
        }

        return "";
    }

    public void setValueAt(Object value, int nRow, int nCol)
    {
        Manifest.Attribute attr = (Manifest.Attribute) getRowObject(nRow);

        if ( attr != null )
        {
            if ( nCol == 0 )
            {
                attr.setName(value.toString());
            }
            else if ( nCol == 1 )
            {
                attr.setValue(value.toString());

                if ( attr.getName().equals(Manifest.ATTRIBUTE_MANIFEST_VERSION))
                {
                    jarProject.setVersion(value.toString());
                    fireTableChanged(new TableModelEvent(this));
                }
                else if ( attr.getName().equals("Main-Class"))
                {
                    jarProject.setMainClass(value.toString());
                    fireTableChanged(new TableModelEvent(this));
                }
            }
        }
    }

    public void removeAll()
    {
        data.removeAllElements();
    }

    public void insert()
    {
    }

    public boolean delete(int row)
    {
        if (row < 0 || row >= data.size())
        {
            return false;
        }
        data.removeElementAt(row);
        return true;
    }

}
