package idea.jartool;

import com.intellij.ide.util.TreeClassChooserDialog;
import com.intellij.openapi.project.Project;
import com.intellij.psi.PsiClass;

import javax.swing.*;
import javax.swing.tree.TreeSelectionModel;
import java.awt.*;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import java.util.Vector;

public class MultipleClassSelectDialog
    extends TreeClassChooserDialog
{
    private JList searchList;
    private JTree classTree;

    public MultipleClassSelectDialog(String s, Project p)
    {
        super(s, p);

        searchList = (JList) ((JScrollPane) ((Container) ((Container) ((Container) ((Container) ((Container) super.getContentPane().getComponent(0)).getComponent(0)).getComponent(0)).getComponent(0)).getComponent(0)).getComponent(1)).getViewport().getView();
        searchList.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
        classTree = (JTree) ((JScrollPane) ((Container) ((Container) ((Container) super.getContentPane().getComponent(0)).getComponent(0)).getComponent(1)).getComponent(0)).getViewport().getView();
        classTree.getSelectionModel().setSelectionMode(TreeSelectionModel.DISCONTIGUOUS_TREE_SELECTION);
        searchList.addFocusListener(new FocusAdapter()
        {
            public void focusGained(FocusEvent e)
            {
                classTree.getSelectionModel().clearSelection();
            }
        });
        classTree.addFocusListener(new FocusAdapter()
        {
            public void focusGained(FocusEvent e)
            {
                searchList.clearSelection();
            }
        });
    }

    public void show()
    {
        super.show();

//        if (super.getExitCode () == super.OK_EXIT_CODE) {
//            TreePath[] paths = classTree.getSelectionModel().getSelectionPaths();

//            int[] rows = classTree.getSelectionModel().getSelectionRows();
//            StringBuffer sb = new StringBuffer ("<html>");
//            sb.append(classTree.getPathForRow(1).toString()+"<br>");
//            for (int i = 0; i < paths.length; i++) {
//                sb.append (paths[i]+ "<br>");
//            }
//            sb.append (getSelectedClass ().getQualifiedName () + "<br>");
//            sb.append ("</html");
//            JOptionPane.showMessageDialog (null, sb.toString ());
//        }
    }

    public Vector<String> getSelectedClasses()
    {
        Vector<String> selectedClasses = new Vector<String>();
        if (super.getExitCode() == OK_EXIT_CODE)
        {
            Object[] selObjs = searchList.getSelectedValues();
            for (Object selObj : selObjs)
            {
                selectedClasses.add(((PsiClass) selObj).getQualifiedName());
            }
            if (selectedClasses.size() == 0)
            {
                selectedClasses.add(getSelectedClass().getQualifiedName());
            }
        }
        return selectedClasses;
    }
}
