package idea.jartool;

import java.io.File;
import java.util.Vector;

/**
 * Created by IntelliJ IDEA.
 * User: ruwan
 * Date: 29-Jun-2007
 * Time: 01:15:16
 */
public class PathConverter
{
    public static String PROJECT_DIR = "$PROJECT_DIR$";

    public static String toRelativePath(Vector<String> dirs, String filePath)
    {
        String ret = PROJECT_DIR;

        if (filePath != null && !dirs.isEmpty())
        {
            for (int i = 0; i < dirs.size(); i++)
            {
                String dir = dirs.elementAt(i);

                if (filePath.startsWith(dir))
                {
                    return ret + filePath.substring(dir.length());
                }
                ret += File.separator + "..";
            }
        }

        return filePath;
    }

    public static String toAbsolutePath(Vector<String> dirs, String filePath)
    {
        int dirindex = 0;
        if (filePath != null && filePath.startsWith(PROJECT_DIR))
        {
            int last = filePath.lastIndexOf(File.separator+"..")+3;

            if ( last > 2 )
            {
                String sub = filePath.substring(PROJECT_DIR.length(),  last );
                dirindex = sub.length()/3;
            }
            else
            {
                last = PROJECT_DIR.length();
            }
            return dirs.elementAt(dirindex)+filePath.substring(last);
        }

        return filePath;
    }


    public static void main(String[] args)
    {
        String path = "F:\\projects\\JarPlugin\\src\\";

        File f = new File(path);

        Vector<String> paths = new Vector<String>(1);

        while (f.getParentFile() != null)
        {
            System.out.println("f.getAbsolutePath() = " + f.getAbsolutePath());
            paths.addElement(f.getAbsolutePath());
            f = f.getParentFile();
        }


        String file1 = "E:\\travelboxv3\\codegen\\CommonLibraries\\archives\\it.codegen.util.jar";
        String file2 = "F:\\projects\\HDProject\\LoanCal\\LoanCal.jar";
        String file3 = "F:\\projects\\JarPlugin\\xxxx\\xxx.jar";
        String file4 = "F:\\projects\\JarPlugin\\src\\yy.jar";


//        System.out.println(toRelativePath(paths, file1));
        System.out.println(file1);
        System.out.println(toRelativePath(paths, file1));
        System.out.println(toAbsolutePath(paths, toRelativePath(paths, file1)));
        System.out.println(file2);
        System.out.println(toRelativePath(paths, file2));
        System.out.println(toAbsolutePath(paths, toRelativePath(paths, file2)));
        System.out.println(file3);
        System.out.println(toRelativePath(paths, file3));
        System.out.println(toAbsolutePath(paths, toRelativePath(paths, file3)));
        System.out.println(file4);
        System.out.println(toRelativePath(paths, file4));
        System.out.println(toAbsolutePath(paths, toRelativePath(paths, file4)));
    }
}
