package idea.jartool;

import idea.tableutils.SelectionCellRenderer;
import idea.tableutils.SelectionCheckCellRenderer;

import javax.swing.*;
import javax.swing.table.TableColumn;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */

public class SelectionScrollPane extends JScrollPane implements ActionListener
{
    JTable table = new JTable();
    private SelectionTableModel tableModel;
    String name;
    JPopupMenu popupSelect = new JPopupMenu();
    JMenuItem selectAll = new JMenuItem();
    JMenuItem deSelectAll = new JMenuItem();

    public SelectionScrollPane(String name)
    {
        this.name = name;
        try
        {
            jbInit();
            setupGUI();
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
        }
    }

    private void jbInit() throws Exception
    {
        getViewport().add(table, null);
        selectAll.setText("Select All");
        selectAll.addActionListener(this);
        deSelectAll.setText("De-Select All");
        deSelectAll.addActionListener(this);

        popupSelect.add(selectAll);
        popupSelect.add(deSelectAll);
    }

    void setupGUI()
    {
        TableColumn column;
        JCheckBox editorCheckBox = new JCheckBox();

        tableModel = new SelectionTableModel(name);

        table.setAutoCreateColumnsFromModel(false);
        table.setModel(tableModel);
        table.getTableHeader().setReorderingAllowed(false);

        table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);

        for (int k = 0; k < tableModel.getColumnCount(); k++)
        {
            if (k == 0)
            {
                SelectionCheckCellRenderer chkRenderer = new SelectionCheckCellRenderer();
                chkRenderer.setHorizontalAlignment(tableModel.getColumn(k).getAlignment());
                editorCheckBox.setHorizontalAlignment(tableModel.getColumn(k).getAlignment());
                DefaultCellEditor editor = new DefaultCellEditor(editorCheckBox);
                column = new TableColumn(k, tableModel.getColumn(k).getWidth(), chkRenderer, editor);
            }
            else
            {
                SelectionCellRenderer textRenderer = new SelectionCellRenderer();
                textRenderer.setHorizontalAlignment(tableModel.getColumn(k).getAlignment());
                column = new TableColumn(k, tableModel.getColumn(k).getWidth(), textRenderer, null);
            }
            table.addColumn(column);
        }

        MouseListener mouseListener = new MouseAdapter()
        {
            public void mouseReleased(MouseEvent e)
            {
                if (e.isPopupTrigger())
                {
                    if (e.getSource() == this || e.getSource() == table)
                    {
                        popupSelect.show((Component) e.getSource(), e.getX(), e.getY());
                    }
                }
            }
        };


        this.addMouseListener(mouseListener);
        table.addMouseListener(mouseListener);
    }

    public void setData(Vector data)
    {
        tableModel.setData(new Vector(data));
        tableModel.fireTableDataChanged();
    }

    public Vector getData()
    {
        return tableModel.getData();
    }

    public void actionPerformed(ActionEvent e)
    {
        if (e.getSource() == selectAll)
        {
            for (int i = 0; i < tableModel.getData().size(); i++)
            {
                ((SelectionItem) tableModel.getData().elementAt(i)).setSelected(true);
            }
            tableModel.fireTableDataChanged();
        }
        else if (e.getSource() == deSelectAll)
        {
            for (int i = 0; i < tableModel.getData().size(); i++)
            {
                ((SelectionItem) tableModel.getData().elementAt(i)).setSelected(false);
            }
            tableModel.fireTableDataChanged();
        }

    }
}

