package idea.tableutils;

import javax.swing.*;
import javax.swing.table.DefaultTableCellRenderer;
import java.awt.*;

/**
 * Created by IntelliJ IDEA.
 * User: Sanjeewa Ruwan
 * Date: Feb 23, 2005
 * Time: 4:56:04 PM
 */
public class SelectionCellRenderer extends DefaultTableCellRenderer
{
     public Component getTableCellRendererComponent( JTable table, Object value, boolean rowSelected, boolean hasFocus, int row, int column )
    {
        Component cmp = super.getTableCellRendererComponent( table, value, rowSelected, hasFocus, row, column );

        if (rowSelected)
		{
            //row is selected, paint by the row selection colors
            cmp.setForeground(table.getSelectionForeground());
			cmp.setBackground(table.getSelectionBackground());
		}
        else if( ( Boolean )table.getModel().getValueAt( row, 0 )  )
        {
            //the tick box is selected hence show in a highlighted color
            cmp.setBackground( new Color( 235,209,252  ) );
            //for ground is needed as the selection forground is set in row selection
            cmp.setForeground(table.getForeground());
        }
        else
        {
            //not a selected row, use default colors to paint
            setBackground(table.getBackground());
            //for ground is needed as the selection forground is set in row selection
            cmp.setForeground(table.getForeground());
        }
        return cmp;
    }
}
