package idea.tableutils;

import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.border.EmptyBorder;
import javax.swing.table.TableCellRenderer;
import java.awt.*;

/**
 * Created by IntelliJ IDEA.
 * User: Sanjeewa Ruwan
 * Date: Feb 23, 2005
 * Time: 4:56:04 PM
 */
public class SelectionCheckCellRenderer  extends JCheckBox implements TableCellRenderer
{
    protected static Border m_noFocusBorder;

    public SelectionCheckCellRenderer()
    {
        super();
        m_noFocusBorder = new EmptyBorder(1, 2, 1, 2);
        setOpaque(true);
        setBorder(m_noFocusBorder);
    }

    public Component getTableCellRendererComponent( JTable table, Object value, boolean rowselected, boolean hasFocus, int row, int column )
    {
        //selecting the chaeck box (only the renderer to display)
        setSelected( ( ( Boolean) value ) );

        if (rowselected)
        {
            //if the row is on selected thent he color is changed to the table selection colors, elese the colors are
            //varied by the selection by the tick box
            setForeground(table.getSelectionForeground());
            setBackground(table.getSelectionBackground());
        }
        else if((Boolean) value )
        {
            //the trow is selected by the tick box, hence color
            setBackground( new Color( 235,209,252 ) );
            //for ground is needed as the selection forground is set in row selection
            setForeground(table.getForeground());
        }
        else
        {
            //this is a non selcted row, use the default colors
            setBackground(table.getBackground());
            //for ground is needed as the selection forground is set in row selection
            setForeground(table.getForeground());
        }

        return this;
    }
}
