package idea.tableutils;

import javax.swing.table.JTableHeader;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

public class SortableHeaderListner extends MouseAdapter
{
    JTableHeader header;
    SortButtonRenderer renderer;

    /**
     * Construcotr
     * @param header
     */
    @SuppressWarnings({"JavaDoc"})
    public SortableHeaderListner(JTableHeader header, SortButtonRenderer renderer)
    {
        this.header = header;
        this.renderer = renderer;
    }

    public void mousePressed(MouseEvent e)
    {
        int col = header.columnAtPoint(e.getPoint());
        int sortCol = header.getTable().convertColumnIndexToModel(col);
        renderer.setPressedColumn(col);
        renderer.setSelectedColumn(col);
        header.repaint();

        if (header.getTable().isEditing())
        {
            header.getTable().getCellEditor().stopCellEditing();
        }

        boolean isAscent;
        isAscent = SortButtonRenderer.DOWN == renderer.getState(col);

        ((SortableTableModel) header.getTable().getModel()).sortByColumn(sortCol, isAscent);
    } // end mouse pressed

    public void mouseReleased(MouseEvent e)
    {
        renderer.setPressedColumn(-1);                // clear
        header.repaint();
    }
}